/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ccb.h 7905 2013-09-25 08:20:15Z whirahashi $
 */

/*
 *  ֥å
 */
#ifndef TOPPERS_CCB_H
#define TOPPERS_CCB_H

#include "target_ccb.h"

#ifndef TOPPERS_MACRO_ONLY

#include "queue.h"
#include "spinlock.h"

/*
 *  
 */
typedef struct task_control_block					TCB;
typedef struct isr_control_block					ISRCB;
typedef struct os_application_initialization_block	OSAPINIB;

/*
 *		֥å
 */
struct core_control_block {

	CoreIdType coreid;

	/*
	 *  ͥư֥ե饰
	 */
	boolean kerflg;

	/*
	 *  SuspendAllInterrupts ΥͥȲ
	 *
	 *  sus_all_cntϥƥΤǤΥͥȲ
	 *  sus_all_cnt_ctxϽñ̤ĤͥȲ
	 */
	uint8	sus_all_cnt;
	uint8	sus_all_cnt_ctx;

	/*
	 *  SuspendOSInterrupts ΥͥȲ
	 *
	 *  sus_os_cntϥƥΤǤΥͥȲ
	 *  sus_os_cnt_ctxϽñ̤ĤͥȲ
	 */
	uint8	sus_os_cnt;
	uint8	sus_os_cnt_ctx;

	/*
	 *  OS¹Τѿ
	 */
	uint16 callevel_stat;       /* ¹Υƥ */

#if TTYPE_KLOCK == C_KLOCK
	/*
	 *  åѿ
	 */
	LockType	tsk_lock;
	LockType	cnt_lock;
#endif /* TTYPE_KLOCK == C_KLOCK */

	/*
	 *		Ϣ
	 */

	/*
	 *  ¹Ծ֤Υ
	 *
	 *  ¹Ծ֤ΥʡץåƥȤäƤ륿ˤ
	 *  TCBؤݥ󥿡¹Ծ֤ΥʤNULLˤ롥
	 *
	 *  ӥνǡʥӥƤӽФ
	 *  ˤ˴ؤ򻲾Ȥp_runtskȤp_runtsk񤭴
	 *  ΤϡǥѥåʤȽˤΤߤǤ롥
	 */
	TCB *p_runtsk;

	/*
	 *  ǹ̤ͥΥ
	 *
	 *  ¹ԤǤ륿Ǻǹ̤ͥΥTCBؤݥ󥿡
	 *  ԤǤ륿ʤNULLˤ롥
	 *
	 */
	TCB *p_schedtsk;

	/*
	 *  ǥ塼κǹͥ
	 *  ǥ塼ˤϼ¹Բǽ֤ΥΤߤޤΤǡ¹Բǽ֤
	 *  Ǥκǹͥ٤ݻ롥ǥ塼λʼ¹Բǽ
	 *  ֤Υ̵ˤ TPRI_MINTASKˤ롥
	 */
	PriorityType nextpri;

	/*
	 *  ǥ塼
	 *
	 *  ǥ塼ϡ¹ԤǤ֤Υ뤿Υ塼Ǥ롥
	 *  ¹Ծ֤ΥƤ뤿ᡤǥʼ¹Բǽ˥塼Ȥ
	 *  ̾ΤΤǤϤʤǥ塼Ȥ̾Τ夷Ƥ뤿ᡤ
	 *  ̾ΤǸƤ֤Ȥˤ롥
	 *
	 *  ǥ塼ϡͥ٤ȤΥ塼ǹƤ롥
	 *  TCBϡͥ٤Υ塼Ͽ롥
	 */
	QUEUE ready_queue[TNUM_TPRI];

	/*
	 *  ǥ塼ΤΥӥåȥޥå
	 *
	 *  ǥ塼ΥΨ褯Ԥˡͥ٤ȤΥ塼
	 *  ˥äƤ뤫ɤ򼨤ӥåȥޥåפѰդƤ롥ӥ
	 *  ȥޥåפȤȤǡꥢβ򸺤餹ȤǤ뤬
	 *  ӥå̿᤬¤Ƥʤץåǡͥ٤ʳʤ
	 *  ˤϡӥåȥޥåΥСإåɤΤˡդ˸Ψ
	 *  ǽ⤢롥
	 */
	uint16 ready_primap;

	/*
	 *		ߴϢ
	 */
	/*
	 *  ¹C2ISR
	 *
	 *  C2ISR¹ԤƤʤϡISRID_NULL ˤ롥
	 */
	ISRCB *p_runisr;

	/*
	 *  wrap_sus_all_int ΥͥȲ
	 */
	uint8 wrap_sus_all_cnt;

	/*
	 *  wrap_sus_os_int ΥͥȲ
	 */
	uint8 wrap_sus_os_cnt;

	/*
	 *  顼եåϤǼѿ
	 */
	OSServiceIdType	_errorhook_svcid;
	_ErrorHook_Par	_errorhook_par1;
	_ErrorHook_Par	_errorhook_par2;
	_ErrorHook_Par	_errorhook_par3;
	_ErrorHook_Par	errorhook_par1;
	_ErrorHook_Par	errorhook_par2;
	_ErrorHook_Par	errorhook_par3;

	/*
	 *  桼ֳ׵ӥåȥޥå
	 */
	uint32 ici_request_map;

	/*
	 *  ǥѥåѥֳ׵ե饰
	 */
	boolean ici_disreqflg;

	/*
	 *  ¹OSץꥱ
	 */
	const OSAPINIB *p_runosap;

	/*
	 *  åȰ¸ ȥ֥å
	 */
	TCCB target_ccb;

	/*
	 * ץƥեåѥԥå֥åݥ
	 */
	SPNCB *p_protectspncb;
};

/*
 *  CCBؤΥơ֥Os_Lcfg.c
 */
extern CCB * const p_ccb_table[];

/*
 *   CCBɥ쥹ؿ
 */
LOCAL_INLINE CCB *
get_my_p_ccb(void)
{
	return((CCB *) x_ccb_adr());
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CCB_H */
