/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: scheduletable.h 7325 2013-04-05 06:23:17Z shigihara $
 */

/*
 *		塼ơ֥뵡ǽ
 */

#ifndef TOPPERS_SCHEDULETABLE_H
#define TOPPERS_SCHEDULETABLE_H

#include "counter.h"

/*
 *  λơ֥üλǥå
 */
#define EXPPTINDEX_TOP			((uint8) 0x00)
#define EXPPTINDEX_INITIAL		((uint8) 0xff)

/*
 *  塼ơ֥ID饹塼ơ֥֥åФΥޥ
 */
#define get_schtblcb(schtblid)	(p_schtblcb_table[(schtblid)])

/*
 *  Ʊ塼ơ֥˴ؤ
 */
#define is_implschtbl(schtblid)	((schtblid) < tnum_implscheduletable)

/*
 *  ġλơ֥뷿
 */
typedef struct scheduletable_expire_point_block {
	TickType		offset;                                 /* եå */
	FunctionRefType	expptfnt;                               /* λؿΥݥ */
} SCHTBLEXPPTCB;


/*
 *  塼ơ֥֥å
 */
typedef struct scheduletable_initialization_block {
	CNTCB				*p_cntcb;                           /* ư󥿴֥åΥݥ */
	TickType			length;                             /* Ĺ */
	AppModeType			autosta;                            /* ư륢ץꥱ⡼ */
	AttributeType		actatr;                             /* ưư° */
	TickType			staval;                             /* ưưƥå */
	const SCHTBLEXPPTCB	*p_exppt;                           /* λơ֥Ƭݥ */
	boolean				repeat;                             /* ̵ͭ */
	uint8				tnum_exppt;                         /* λ */

	const OSAPINIB *p_osapinib;                             /* °OSץꥱ֥å */
} SCHTBLINIB;

/*
 *  塼ơ֥֥å
 */
typedef struct scheduletable_control_block {
	CNTEXPINFO							cntexpinfo;         /* λ(¤ΤƬɬ) */
	const SCHTBLINIB					*p_schtblinib;      /* ֥åؤΥݥ */
	struct scheduletable_control_block	*p_prevschtblcb;    /* ʬNextˤ塼ơ֥֥åؤΥݥ */
	struct scheduletable_control_block	*p_nextschtblcb;    /* Next塼ơ֥֥åؤΥݥ */
	ScheduleTableStatusType				status;             /* 塼ơ֥ */
	uint8								expptindex;         /* λǥå */
} SCHTBLCB;

/*
 *  λ¹Ѵ
 */
typedef struct scheduletable_expire_info {
	SCHTBLCB *p_schtblcb;                                   /* 塼ơ֥֥åΥɥ쥹 */
} SCHTBLEXPINFO;

/*
 *  塼ơ֥ݻѿ
 */
extern const ScheduleTableType	tnum_scheduletable;         /* 塼ơ֥ο */
extern const ScheduleTableType	tnum_implscheduletable;     /* Ʊ塼ơ֥ */

/*
 *  塼ơ֥֥åΥꥢOs_Lcfg.c
 */
extern const SCHTBLINIB			schtblinib_table[];

/*
 *  塼ơ֥֥åΥꥢOs_Lcfg.c
 */
extern SCHTBLCB * const		p_schtblcb_table[];

/*
 *  塼ơ֥륪֥Ȥν
 */
extern void schtbl_initialize(void);

/*
 *  塼ơ֥λؿ
 */
extern void schtbl_expire(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb);

/*
 *  λؿƥߥ󥰽μ¹
 */
extern void schtbl_expiry_process(SCHTBLEXPINFO *p_schtblexpinfo, const CNTCB *p_cntcb);

/*
 *  塼ơ֥γϽ
 */
extern boolean schtbl_head(SCHTBLCB *p_schtblcb, const CNTCB *p_cntcb);

/*
 *  塼ơ֥γλ
 */
extern boolean schtbl_exppoint_process(SCHTBLCB *p_schtblcb, const CNTCB *p_cntcb);

/*
 *  塼ơ֥νü
 */
extern boolean schtbl_tail(SCHTBLCB *p_schtblcb, SCHTBLEXPINFO *p_schtblexpinfo, const CNTCB *p_cntcb);

#endif /* TOPPERS_SCHEDULETABLE_H */
