/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: serial.c 7023 2013-02-13 02:09:04Z fujitsu-wada $
 */

/*
 *		ץꥢIO⥸塼
 */

#include	"Os.h"
#include	"target_serial.h"
#include	"target_sysmod.h"
#include	"serial.h"


/*
 *  ѥǡ
 */

static uint8	rx_char[TotalNumberOfCores];
static boolean	rx_flag[TotalNumberOfCores];

/*
 *  ꥢIO⥸塼
 *
 *  ߶ػ߾֤ǸƽФ
 */
void
InitSerial(void)
{
	CoreIdType coreid;

	/*
	 *  ե饰
	 */
	coreid = GetCoreID();
	rx_flag[coreid] = FALSE;

	/*
	 *  ¸¹
	 */
	InitHwSerial();
}

/*
 *  ꥢIO⥸塼߽
 *
 *  ϤλƤ뤳Ȥݾ㤷ʤʥǥåɥåɻߡ
 *  ƥȥåƽϤΤǡۤʤʺǸΣʸΤߡ
 *
 *  ߶ػ߾֤ǸƽФ
 */
void
TermSerial(void)
{
	CoreIdType coreid;

	/*
	 *  ¸¹
	 */
	TermHwSerial();

	/*
	 *  ǡ̵
	 */
	coreid = GetCoreID();
	rx_flag[coreid] = FALSE;
}

/*
 *  ʸ
 */
void
RecvPolSerialChar(uint8 *character)
{
	CoreIdType coreid;

	coreid = GetCoreID();
	SuspendAllInterrupts();
	if (rx_flag[coreid] != FALSE) {
		/*
		 *  ߶ػߤˤƼǡե饰ꥢ
		 */
		*character = rx_char[coreid];
		rx_flag[coreid] = FALSE;
	}
	else {
		/*
		 *  ǡʤ'\0'֤
		 */
		*character = '\0';
	}
	ResumeAllInterrupts();
}

/*
 *  Хåؿ
 */
void
RxSerialInt(uint8 character)
{
	CoreIdType coreid;

	coreid = GetCoreID();
	/*
	 *  ߶ػߤˤƼǡݻե饰ꥢ
	 */
	SuspendAllInterrupts();
	rx_char[coreid] = character;
	rx_flag[coreid] = TRUE;
	ResumeAllInterrupts();
}
